#!/bin/sh

. /lib/functions.sh


device="/dev/mmcblk0"
duel_part="p3"
first_part="p2"


fstab_enable() {                                                                                                                               
        local config=$1                                                                                                                        
        local uuid=$2                                                                                                                          
        local mount_point=$3                                                                                                                   
                                                                                                                                               
        config_get x $config "uuid"                                                                                                            
                                                                                                                                               
        echo "x is: [$x] vs [$uuid]"                                                                                                           
        if [ "$x" = "$uuid" ] ; then                                                                                                           
                echo "Enabling $x...."                                                                                                         
                uci_set fstab $config enabled 1                                                                                                
                if [ -n "$mount_point" ]; then                                                                                                 
                        uci_set fstab $config "target" $mount_point                                                                            
                fi                                                                                                                             
        else                                                                                                                                   
                echo "Not a match"                                                                                                             
        fi                                                                                                                                     
}                                                                                                                                              
                                                                                                                                               
setup_fstab() {                                                                                                                                
        local device=$1                                                                                                                        
        local mount_point=$2                                                                                                                   
                                                                                                                                               
        if [ ! -d "$mount_point" ] ; then                                                                                                      
                mkdir -p $mount_point                                                                                                          
        fi                                                                                                                                     
        config_load fstab                                                                                                                      
                                                                                                                                               
        tmp=$(block info $device | awk -F: '{print $2}' | tr -d '"')                                                                           
        echo "tmp is $tmp"                                                                                                                     
        export $tmp                                                                                                                            
        echo "UUID is $UUID"                                                                                                                   
                                                                                                                                               
        config_foreach fstab_enable mount "$UUID" "$mount_point"                                                                               
                                                                                                                                               
        uci commit fstab                                                                                                                       
        sleep 1                                                                                                                                
}                                                                                                                                              
                                                                                                                                               







# I thought this should be or not and..

fdisk -l ${device}${duel_part} 2>/dev/null && {
	echo "Partition Already exists exiting..."
	exit 0
}

echo "No secondary partition"

first_part_end_sector=$(fdisk -l -o Start,End,Device $device | grep ${device}${first_part} | awk '{print $2}')

sectors=$(fdisk -l $device | grep "Disk $DRIVE" | awk '{print $7}')
end_sector=$(($sectors - 1 ))

first_part_size=$(fdisk -l -o Size,Device $device | grep ${device}${first_part} | awk '{print $1}')

echo "first_part_end_sector: $first_part_end_sector"
start_sector=$(($first_part_end_sector+1))
echo "start_sector: $start_sector"
echo "first_part_size: $first_part_size"
echo "sectors: $sectors"
echo "end_sector: $end_sector"

# partition the drive

{
	echo n
	echo p
	echo 3
	echo $start_sector
	echo "$end_sector"
	echo "p"
	echo "w"
} | fdisk $device



grep -q ${device}p3 /etc/fstab || {
        mkdir -p /opt/novatec/postgres
	chown postgres.postgres /opt/novatec/postgres
        echo ${device}p3      /opt/novatec/postgres       ext4 rw 0 2 >> /etc/fstab
}


#Format partitions

 mkfs.ext4 -F -q ${device}p3

# Merge fstab into fstab config.            
                                            
block detect | uci -m import fstab          
                                            
# Setup fstab config                                                   
                                            
setup_fstab "${device}p3" "/opt/novatec/postgres"                              
                                         
#mount devices                           
                                         
block umount                             
block mount                              
                                           
#mount -a                                
                                         
#Replicate postgress data to mount point.                         



mount -a

