#!/bin/sh


STAT_MONITOR_DIR="/tmp/stat_monitor"

processes="novatec-transport ble_data_acquisition ota_beat fvw-heartbeat ble-utild mdh_discovery_client sensor_status.py"



mkdir -p $STAT_MONITOR_DIR


print_header() {


	vm_header="VmPeak VmSize VmLck VmPin VmHWM VmRSS VmData VmStk VmExe VmLib VmPTE VmSwap"
	statm_header="size resident shared text lib data dt"
	echo "uptime pid $statm_header $vm_header"
	return 0
}

log_process_stats() {
	upt=$(cat /proc/uptime | cut -d " " -f 1)
	for process in $processes
	do
		stat_file_out=${STAT_MONITOR_DIR}/$process.statlog
		[ ! -s "$stat_file_out" ] && print_header > $stat_file_out
		pid=$(pidof $process) || {
			echo "Failed to get pid for $process"
			continue
		}
		stat_in_file=/proc/$pid/statm
		stat_data=$(cat $stat_in_file)
		vm_data=$(cat /proc/$pid/status | grep Vm | awk '{print $2}')
		echo $upt $pid $stat_data $vm_data >> $stat_file_out
	
	done
}


while [ true ]; do
	log_process_stats
	sleep 300
done


